#usage:                   <MTExtendInclude blog_id="2"module="test">

use strict;
use MT::Plugin;

my $plugin = MT::Plugin->new;
$plugin->name("ExtendInclude");
$plugin->description('This plugin extend for select blog at MTInclude.');
MT->add_plugin($plugin);
#*MT::Template::Context::_hdlr_include = \&_hdlr_include_more;
MT::Template::Context->add_tag('ExtendInclude' => \&_hdlr_include_more);

use File::Spec;

sub _hdlr_include_more {
    my($ctx, $arg, $cond) = @_;
    my $req = MT::Request->instance;
    my $blog_id = $arg->{blog_id} || $ctx->{__stash}{blog_id};
    if (my $tmpl_name = $arg->{module}) {
        my $builder = $ctx->{__stash}{builder};
        my $stash_id = 'template_module::' . $blog_id . '::' . $tmpl_name;
        my $tokens = $req->stash($stash_id);
        unless ($tokens) {
            require MT::Template;
            my $tmpl = MT::Template->load({ name => $tmpl_name,
                                            blog_id => $blog_id })
                or return $ctx->error(MT->translate(
                    "Can't find included template module '[_1]'", $tmpl_name ));
            $tokens = $builder->compile($ctx, $tmpl->text);
            $req->stash($stash_id, $tokens);
        }
        my $ret = $builder->build($ctx, $tokens, $cond);
        return defined($ret) ? $ret : $ctx->error($builder->errstr);
    } elsif (my $file = $arg->{file}) {
        my $stash_id = 'template_file::' . $blog_id . '::' . $file;
        my $cref = $req->stash($stash_id);
        my $c;
        if ($cref) {
            $c = $$cref;
        } else {
            my $blog = $ctx->stash('blog');
            my @paths = ($file, map File::Spec->catfile($_, $file),
                                $blog->site_path, $blog->archive_path);
            my $path;
            for my $p (@paths) {
                $path = $p, last if -e $p && -r _;
            }
            return $ctx->error(MT->translate(
                "Can't find included file '[_1]'", $file )) unless $path;
            local *FH;
            open FH, $path
                or return $ctx->error(MT->translate(
                    "Error opening included file '[_1]': [_2]", $path, $! ));
            local $/; $c = <FH>;
            close FH;
            $req->stash($stash_id, \$c);
        }
        return $c;
    }

}